#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>
#include <getopt.h>

#define BUFSIZE         65536

int lflag;
int sflag;

int main(int argc, char *argv[])
{
    int ch;
    char *service="finger";
    char hostbuf[256];

    gethostname(hostbuf, 256);
    
    /*zpracovani vstupnich prepinacu a nastaveni flagu*/
    while ((ch = getopt(argc, argv, "ls")) != EOF) {
        switch(ch) {
        case 'l':
            lflag = 1;		/* long format */
            break;
        case 's':
            sflag = 1;		/* short format */
            break;
        case '?':
        case 'h':
        default:
            fprintf(stderr, "usage: finger [-ls] [login ...]\n");
            return 1;
        }
    }
    argc -= optind;
    argv += optind;

    /* Prikaz ve tvaru finger [-ls] */
    if (argc == 0) {
        finger ("", hostbuf, service);
        exit (0);
    }

    while(argc > 0)
    {
        char* ret;
        ret = strchr(argv[0], '@');

        /* Prikaz ve tvaru finger [-ls] login */
        if (ret == NULL)
            finger (argv[0], hostbuf, service);

        /* Prikaz ve tvaru finger [-ls] @host */
        else if (ret == 0)
            finger ("", ret + 1, service);

        /* Prikaz ve tvaru finger [-ls] login@host */
        else {
            *ret = '\0';
            finger (argv[0], ret + 1, service);
        }
        
        argc--;
        argv++;

    }
    return (0);
}


finger (char* user, char* host, char* service)
{
    char  buf[BUFSIZE];
    int s, n, m, lout;

    s=connectTCP(host, service);
    
    if (lflag == 1)
        sprintf(buf,"/W %s\r\n", user);
    else if (sflag == 1)
        sprintf(buf,"-s %s\r\n", user);
    else
        sprintf(buf,"%s\r\n", user);
    
    lout=strlen(buf)+1;
    
    /* Odeslani pozadavku */
    write(s, buf, lout);

    /* Nacteni odpovedi */
    m=0;
    do {
        if (m == BUFSIZE) break;
        n=read(s, &buf[m], BUFSIZE-m);
        m+=n;
        if (n < 0)
        {
            perror("finger() ");
            exit(1);
        }
    } while (n != 0);

    buf[m] = '\0';
        
    /* Zobrazeni odpovedi */
    printf("%s\n", buf);

    close(s);
}
